#
#  AppController.rb
#  ScreenCast
#
#  Created by Heiko Kretschmer on 2007/2008.
#  Copyright (c) 2007/2008 Heiko Kretschmer. All rights reserved.
#

require 'osx/cocoa'

# Klasse "AppController"
class AppController < OSX::NSObject

 # Defines
 

 # Includes
 include OSX

 # Outlets
 ib_outlets :window, :intervalTextfield, :autostartCheckbox, :startStopButton, :progressIndicator, :statusTextfield, :labelleftTextfield, :labelrightTextfield, :urlsTextfield
 
 # Globals
 $globals = Hash.new
 $globals = { "interval" => 60, "startatlaunch" => 0, "running" => 0 } # Defaults, bis die Prefs geladen sind
 
 ###########################################
 $globals ["debug"] = 1 # Debug = ENABLED
 #$globals ["debug"] = 0 # Debug = DISABLED
 ###########################################

  # Methoden #########################

  # AwakeFromNib
  def awakeFromNib
	Say("Awaking from nib.")
 
	# Window config
	@window.setFrameAutosaveName("ScreenCast Window")
 
	# Preferences lesen
	preferencesRead()
	
	# Preferences in window anzeigen
	preferencesApply()
 
	# Ggf. Autostart
	if ($globals["startatlaunch"].to_i == 1) then
		Say("startatlaunch -> start")
		startThread()
	end
  end # of awakeFromNib

  # Preferences lesen
  def preferencesRead()
    # Preferences laden, ggf. auf Default setzen
	$globals["interval"] = OSX::NSUserDefaults.standardUserDefaults.objectForKey("interval")
	if $globals['interval'] == nil then
		$globals['interval'] = 60
	end
	$globals["startatlaunch"] = OSX::NSUserDefaults.standardUserDefaults.objectForKey("startatlaunch")
	if $globals["startatlaunch"] == nil then
		$globals["startatlaunch"] = 0
	end
	Say("Interval: %@, startatlaunch: %@", $globals["interval"].to_s, $globals["startatlaunch"].to_s)
  end # preferencesRead

  # Preferences in window anwenden
  def preferencesApply()
	@intervalTextfield.stringValue=$globals["interval"].to_s
	@autostartCheckbox.state=$globals["startatlaunch"].to_s
  end # preferencesApply

  # Preferences speichern
  def preferencesWrite()
	defaults = OSX::NSUserDefaults.standardUserDefaults
		defaults.setObject_forKey($globals["interval"].to_s, 'interval')
		defaults.setObject_forKey($globals["startatlaunch"].to_s, 'startatlaunch')
    defaults.synchronize
  end # preferencesWrite

 # About Window
  def aboutApp (sender)
    thisBundle = OSX::NSBundle.mainBundle
	copyrightString = thisBundle.objectForInfoDictionaryKey("CFBundleGetInfoString")
	versionString   = thisBundle.objectForInfoDictionaryKey("VersionString")
	NSApp.orderFrontStandardAboutPanelWithOptions("Copyright" => copyrightString, "ApplicationVersion" => versionString)
    # NSApp.orderFrontStandardAboutPanelWithOptions("Copyright" => "RubyCocoa #{RUBYCOCOA_VERSION}", "ApplicationVersion" => "Ruby #{VERSION}")
  end # aboutApp 
  ib_action :aboutApp

  # Wenn die autostart-Checkbox has been clicked
  def autostartCheckboxClicked (sender)
	Say("autostartCheckbox has been called.")
	$globals["startatlaunch"]=@autostartCheckbox.state
	preferencesWrite()
  end #autostartCheckboxClicked
  ib_action :autostartCheckboxClicked

  # Wenn das Interval-Textfield has been changed
  def intervalTextBoxClicked (sender)
	Say("intervalTextBoxClicked has been called.")
	$globals["interval"]=@intervalTextfield.stringValue
	preferencesWrite()
  end # intervalTextBoxClicked
  ib_action :intervalTextBoxClicked

  # Wenn die Start/Stop-Button-Checkbox has been clicked
  def startStopButtonClicked (sender)
	Say("startStopButtonClicked has been called.")
	if $globals['running'] == 0 then
	   startThread()
	else
	   stopThread()
	end
  end # startStopButtonClicked
  ib_action :startStopButtonClicked
 
  # Starten
  def startThread()
	Say("Starting Thread.")
	$globals['running'] = 1
	@intervalTextfield.setEnabled_(false)
	@autostartCheckbox.setEnabled_(false)
	@labelleftTextfield.setEnabled_(false)  # tut Cocoa garnid :)
	@labelrightTextfield.setEnabled_(false) # tut Cocoa garnid :)
	@statusTextfield.setStringValue_("Status: Running")
	if @thread == nil then
      @startStopButton.setTitle("Stop")

 	  $thread = Thread.new do
		loop do
			Say("thread: %@", $thread)
			runShellScript()
			for i in (1...$globals["interval"].to_i) do
				sleep(1.0)
				if ($globals['running']==0) then
					Thread.stop
				end
			end
		end
	  end



 #works 	  $thread = Thread.new { loop { Say("thread: %@", $thread); runShellScript(); sleep($globals["interval"].to_i) } } # hier hat die variable Thread nur bei der ersten Ausgabe "nil"!!


# works 	  thread = Thread.new { loop { Say("thread: %@", thread) } } # hier hat die variable Thread einen Wert!

#	  thread = Thread.new do # liefert auch nur einen nil-pointer!
# 		loop do
#			Say("thread: %p", @thread)
#			Say("thread fump")
#			runShellScript()
#			sleep($globals["interval"].to_i)
#		end # loop
#	  end # thread

#  	  @thread = Thread.start do # Bøg: Thread.start returns *nil*, obwohl der Thread läuft!
#		loop do
#			Say("thread: %p", @thread)
#			Say("thread fump")
#			runShellScript()
#			sleep($globals["interval"].to_i)
#		end # end loop
#	  end # end thread
	  @thread = nil
    end #if thread
	
	# Urls ausgeben
	urlsText = urls()
#	Say("2Urls: %@", urlsText)
	@urlsTextfield.setEditable_(true)
#		[chatIncoming moveToEndOfDocument:self]; // Damit verschiess ich mir die Selection, dafür is aber der Text an der richtigen Stelle eingefügt! :) 2006-05-18
#		[chatIncoming setMark:self];
#		[chatIncoming insertText:string];
#		[chatIncoming selectToMark:self];
#	@urlsTextfield.insertText(urlsText.to_s)
# NIX GUT. Link bleibt gleich, URL-Text geändert -> BAD!	@urlsTextfield.setString(urlsText.to_s)

	range=OSX::NSMakeRange(0, @urlsTextfield.textStorage.length)
	#@urlsTextfield.replaceCharactersInRange_withString(range, urlsText.to_s)
	@urlsTextfield.replaceCharactersInRange_withString(range, "")
	@urlsTextfield.insertText_(urlsText)
	
	#@urlsTextfield.insertText_("http://www.wurst-wasser.net") # Not clickable URL :(
	#no change@urlsTextfield.setAutomaticLinkDetectionEnabled_(true)
	
	#not clickable @testUrl = OSX::NSURL.URLWithString("http://www.wurst-wasser.net/")
	#not clickable @urlsTextfield.insertText_(@testUrl.absoluteString)
	
	@urlsTextfield.setEditable_(false)
  end # startThread
  
  # Funktion um URLs für Textviews aufzubereiten, weil Links bei programmatischem Einfügen nicht automatisch erkannt werden.
  def urlify(urlString)
  	# Hint von Philip Dow @ Cocoa-Developer-List
#	Say("urlString: %@", urlString)
	@myUrl        = OSX::NSURL.alloc.initWithString_(urlString)
	@font		  = OSX::NSFont.fontWithName_size("Lucida Grande", 8.0)
	Say("font: %@, size: %f", @font.displayName, @font.pointSize)
	@urlStyleDict = OSX::NSDictionary.dictionaryWithObjectsAndKeys(@myUrl, NSLinkAttributeName, @font, NSFontAttributeName, nil)
	@preparedText = OSX::NSAttributedString.alloc.initWithString_attributes(urlString, @urlStyleDict)
#	Say("preparedText: %@", @preparedText)
    @preparedText.retain
	return(@preparedText)
  end

  def setStyle(attributedString)
  end

  # Eigene IP & damit die URLs rausfinden
  def urls()
	Say("urls..")
	addresses		= OSX::NSHost.currentHost.addresses # As Schick and ARDMonitor work
	addressesEnum	= addresses.objectEnumerator
	username		= OSX::NSUserName()
#	@font			= OSX::NSFont.systemFontOfSize(OSX::NSFont.smallSystemFontSize)
	@font		    = OSX::NSFont.fontWithName_size("Lucida Grande", 8.0)
	@plainStyleDict = OSX::NSDictionary.dictionaryWithObjectsAndKeys(@font, NSFontAttributeName, nil)
	@res			= OSX::NSMutableAttributedString.alloc.initWithString_attributes("Use this URL(s):\n\n", @plainStyleDict)
	t				= "http://%@/~%@/index.html"
	@footer			= OSX::NSMutableAttributedString.alloc.initWithString("\nPlease make sure \"Web Sharing\" is turned on.\n")
	@lf				= OSX::NSMutableAttributedString.alloc.initWithString("\n")
	@urlstring      = OSX::NSMutableString.alloc.initWithString("")
	
		while (address = addressesEnum.nextObject) # see http://www.regular-expressions.info/regexbuddy/ipaccurate.html
			if (address.to_s =~ /\b(?:(?:25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)\.){3}(?:25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)\b/ and address.to_s!='127.0.0.1') then
				@urlstring.appendFormat(t, address, username)
				#@s = urlify(OSX::NSString.stringWithFormat_(t, address, username))
				@s = urlify(@urlstring)
				@res.appendAttributedString(@s) 
				@res.appendAttributedString(@lf)
			end
		end
		
		# Check, whether websharing if turned on. based on that, append footer
		@urltotest = OSX::NSURL.URLWithString(@urlstring)
		@downloadedstring = OSX::NSString.stringWithContentsOfURL_encoding_error_(@urltotest, NSASCIIStringEncoding, nil)
		Say("@downloadedstring: %s", @downloadedstring)
		serviceNotRunning = true
		if (@downloadedstring) then
			#range = OSX::NSRange.new(@downloadedstring.rangeOfString("ScreenWebCast")); # http://www.rubycocoa.com/an-introduction-to-rubycocoa/4/
			range = @downloadedstring.rangeOfString("ScreenWebCast")
			Say("range.location: %d", range.location)
			Say("NSNotFound: %d", NSNotFound)
			if (range && range.location != NSNotFound ) then
				serviceNotRunning = false
			end 
		end # if downloadedstring
		if (serviceNotRunning) then
			# Wenn die Webseite nicht geladen wurde -> Footer ausgeben
			@res.appendAttributedString(@footer)
		end # if serviceNotRunning
		
	# Style auch über die LFs und den Footer braten. :)
    @res.addAttributes_range(@plainStyleDict, OSX::NSMakeRange(0, @res.length))

	return (@res)	
   end # urls

  # Stoppen
  def stopThread()
	Say("Stopping Thread.")
#	Say("Stopping Thread %p.", thread)
    $globals['running'] = 0
	@intervalTextfield.setEnabled_(true)
	@autostartCheckbox.setEnabled_(true)
	@labelleftTextfield.setEnabled_(true)   # tut Cocoa garnid :)
	@labelrightTextfield.setEnabled_(false) # tut Cocoa garnid :)
	@statusTextfield.setStringValue_("Status: Stopped")
	@thread.kill if @thread
    @thread = nil
    @startStopButton.setTitle("Start")
  end # stopThread

  # Das Shellscript aufrufen, das den Webcast erstellt
  def runShellScript()
    Say("runShellScript!")
	thisBundle = OSX::NSBundle.mainBundle
	scriptPath = thisBundle.pathForResource_ofType("screencast", "command")
	Say("scriptPath: %@", scriptPath)
	reloadInterval = @intervalTextfield.stringValue
	Say("reloadInterval: %@", reloadInterval)
	commandstring	= "\"" + scriptPath + "\"" + " " + reloadInterval
	Say("commandstring: %@", commandstring)
	
    system(commandstring)
	#system("touch /Users/heiko/Desktop/tescht.txt")
  end

  def Say(*args)
	#if (DEBUGLOGGING!=true) then return # Debugging ist aus -> raus hier
	if ($globals['debug'].to_i==0) then return # Debugging ist aus -> raus hier
	else
		msg = NSString.stringWithFormat_(*args).to_s
		OSX::NSLog("%s.%s: %s", calling_class(), calling_method(), msg)
	end # else !debug
  end # Say

  # http://www.ruby-forum.com/topic/75258
  def this_method 
		caller[0][/`([^']*)'/, 1]
  end

  # http://www.ruby-forum.com/topic/75258
  def calling_method
		caller[1] =~ /`([^']*)'/ and $1
  end

  # http://snippets.dzone.com/posts/show/4966
  def calling_class
		#line_item = LineItem.new
		#puts line_item.class.name.underscore.humanize.lowcase #spits out "line item"
		self.class.name
  end

end # AppController
